using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;

namespace Insight.Web.Pages.Management.Hosts.Systems.Volumes;

[Route(Navigation.Management.Hosts.Systems.Volumes.Details)]
public partial class Details
{
    [Parameter] public string? HostId { get; set; }
    [Parameter] public string? VolumeId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private HostVolumeEntity? HostVolume { get; set; }

    private async Task LoadDataAsync()
    {
        Breadcrumbs.Clear();
        HostVolume = null;

        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));

        StateHasChanged();

        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Volumes", href: Navigation.Management.Hosts.Systems.Volumes.IndexHref(HostId)));

        StateHasChanged();

        if (string.IsNullOrWhiteSpace(VolumeId) || ObjectId.TryParse(VolumeId, out var volumeId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Systems.Volumes.IndexHref(HostId));
            return;
        }

        HostVolume = await Database.HostVolume()
                .Find(p => p.Host == HostId && p.Id == VolumeId)
                .FirstOrDefaultAsync();

        if (HostVolume is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Systems.Volumes.IndexHref(HostId));
            return;
        }

        Title = $"Hosts » {host.Name} » Volume » {HostVolume.Name}｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem(HostVolume.Name, href: "#", true));

        StateHasChanged();
    }
}